'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ModuleImportHelper = require('./ModuleImportHelper');

var _ModuleImportHelper2 = _interopRequireDefault(_ModuleImportHelper);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var t;

var SystemImportExpressionTransformer = function () {
  function SystemImportExpressionTransformer(types, state, params) {
    _classCallCheck(this, SystemImportExpressionTransformer);

    t = types;
    this.state = state;
    this.file = state.file;
    this.pluginOptions = this.state.opts;
    this.moduleType = this.pluginOptions.modules;
    var param = params[0];
    this.importedModuleLiteral = t.stringLiteral(param.node.value);

    var moduleName = new _ModuleImportHelper2.default(t).getImportModuleName(this.file, this.importedModuleLiteral.value);
    this.moduleNameLiteral = t.stringLiteral(moduleName);
  }

  _createClass(SystemImportExpressionTransformer, [{
    key: 'getGlobalIdentifier',
    value: function getGlobalIdentifier() {
      if (this.globalIdentifier) {
        return this.globalIdentifier;
      }
      this.globalIdentifier = new _utils.UtilsHelper(t, this.file).getGlobalIdentifier();
      return this.globalIdentifier;
    }
  }, {
    key: 'getAmdTest',
    value: function getAmdTest() {
      var globalIdentifier = this.getGlobalIdentifier();
      // typeof global.define === 'function' && global.define.amd
      var amdTest = t.logicalExpression('&&', t.binaryExpression('===', t.unaryExpression('typeof', t.memberExpression(globalIdentifier, t.identifier('define'))), t.stringLiteral('function')), t.memberExpression(t.memberExpression(globalIdentifier, t.identifier('define')), t.identifier('amd')));
      return amdTest;
    }
  }, {
    key: 'getAmdRequirePromise',
    value: function getAmdRequirePromise(module) {
      var globalIdentifier = this.getGlobalIdentifier();
      // global.require(['localforageSerializer'], resolve, reject);
      var amdRequire = t.expressionStatement(t.callExpression(t.memberExpression(globalIdentifier, t.identifier('require')), [t.arrayExpression([module]), t.identifier('resolve'), t.identifier('reject')]));

      var newPromiseExpression = t.newExpression(t.identifier('Promise'), [t.functionExpression(null, [t.identifier('resolve'), t.identifier('reject')], t.blockStatement([amdRequire]))]);
      return newPromiseExpression;
    }
  }, {
    key: 'getCommonJSTest',
    value: function getCommonJSTest() {
      // typeof module !== 'undefined' && module.exports && typeof require !== 'undefined'
      var commonJSTest = t.logicalExpression('&&', t.binaryExpression('!==', t.unaryExpression('typeof', t.identifier('module')), t.stringLiteral('undefined')), t.logicalExpression('&&', t.memberExpression(t.identifier('module'), t.identifier('exports')), t.binaryExpression('!==', t.unaryExpression('typeof', t.identifier('require')), t.stringLiteral('undefined'))));
      return commonJSTest;
    }
  }, {
    key: 'getComponentTest',
    value: function getComponentTest() {
      var globalIdentifier = this.getGlobalIdentifier();
      // typeof module !== 'undefined' && module.component && global.require && global.require.loader === 'component'
      var componentTest = t.logicalExpression('&&', t.binaryExpression('!==', t.unaryExpression('typeof', t.identifier('module')), t.stringLiteral('undefined')), t.logicalExpression('&&', t.memberExpression(t.identifier('module'), t.identifier('component')), t.logicalExpression('&&', t.memberExpression(globalIdentifier, t.identifier('require')), t.binaryExpression('===', t.memberExpression(t.memberExpression(globalIdentifier, t.identifier('require')), t.identifier('loader')), t.stringLiteral('component')))));
      return componentTest;
    }
  }, {
    key: 'getCommonJSRequire',
    value: function getCommonJSRequire(module) {
      // resolve(require('./../utils/serializer'));

      var commonJSRequireExpression = t.callExpression(t.identifier('require'),
      // [module] // why this isn't working???
      // [module, t.identifier('undefined')] // had to add extra undefined parameter or parenthesis !?!?!?
      [t.parenthesizedExpression(module)]);
      return commonJSRequireExpression;
    }
  }, {
    key: 'getCommonJSRequirePromise',
    value: function getCommonJSRequirePromise(module) {
      var commonJSRequireExpression = this.getCommonJSRequire(module);
      var commonJSRequire = this.createPromiseResolveExpression(commonJSRequireExpression);
      return commonJSRequire;
    }
  }, {
    key: 'getGlobalRequire',
    value: function getGlobalRequire(module) {
      var globalIdentifier = this.getGlobalIdentifier();

      // resolve(global.localforageSerializer);
      var globalMemberExpression = t.memberExpression(globalIdentifier, module, true // computed
      );
      return globalMemberExpression;
    }
  }, {
    key: 'getGlobalRequirePromise',
    value: function getGlobalRequirePromise(module) {
      var globalMemberExpression = this.getGlobalRequire(module);
      var globalRequire = this.createPromiseResolveExpression(globalMemberExpression);
      return globalRequire;
    }
  }, {
    key: 'createTransformedExpression',
    value: function createTransformedExpression() {
      var moduleImportExpression;
      if (this.moduleType === 'amd') {
        moduleImportExpression = this.getAmdRequirePromise(this.moduleNameLiteral);
      } else if (this.moduleType === 'common') {
        moduleImportExpression = this.getCommonJSRequirePromise(this.importedModuleLiteral);
      } else if (this.moduleType === 'global') {
        moduleImportExpression = this.getGlobalRequirePromise(this.moduleNameLiteral);
      } else {
        // umd
        var amdTest = this.getAmdTest();
        var commonJSTest = this.getCommonJSTest();
        var componentTest = this.getComponentTest();
        var commonJSOrComponentTest = t.logicalExpression('||', commonJSTest, componentTest);

        var umdRequire = t.conditionalExpression(amdTest, this.getAmdRequirePromise(this.moduleNameLiteral), t.conditionalExpression(commonJSOrComponentTest, this.getCommonJSRequirePromise(this.importedModuleLiteral), this.getGlobalRequirePromise(this.moduleNameLiteral)));
        moduleImportExpression = umdRequire;
      }

      return moduleImportExpression;
    }
  }, {
    key: 'createResolveExpressionStatement',
    value: function createResolveExpressionStatement(parameter) {
      var result = t.expressionStatement(t.callExpression(t.identifier('resolve'), [parameter]));
      return result;
    }
  }, {
    key: 'createPromiseResolveExpression',
    value: function createPromiseResolveExpression(parameter) {
      var result = t.callExpression(t.memberExpression(t.identifier('Promise'), t.identifier('resolve')), [parameter]);
      return result;
    }
  }]);

  return SystemImportExpressionTransformer;
}();

exports.default = SystemImportExpressionTransformer;